package ru.landgrafhomyak.bgtu.db0.exe

import java.net.http.HttpClient
import java.sql.DriverManager
import ru.landgrafhomyak.bgtu.db0.impl.Handlers
import ru.landgrafhomyak.bgtu.db0.storage.sqlite_jdbc.JdbcSqliteStorage
import ru.landgrafhomyak.bgtu.db0.telegram.impl.IncomingUpdate
import ru.landgrafhomyak.bgtu.db0.telegram.impl.JavaBlockingHttpClientTelegramApiImpl
import ru.landgrafhomyak.bgtu.db0.telegram.impl.JavaBlockingJson2JsonHttpClient

fun main() {
	val db = JdbcSqliteStorage(DriverManager.getConnection("jdbc:sqlite:test.sqlite"))
	val tg = JavaBlockingHttpClientTelegramApiImpl(
		token = TODO("No token"),
		httpClient = JavaBlockingJson2JsonHttpClient(HttpClient.newHttpClient())
	)

	val impl = Handlers(db)

	tg.receiveUpdatesUntilError { u ->
		try {
			when (u) {
				is IncomingUpdate.TextMessage -> impl.onTextMessage(tg, u.msg)
				is IncomingUpdate.CallbackQuery -> impl.onCallbackQuery(tg, u.query)
			}
		} catch (t: Throwable) {
			t.printStackTrace()
		}
	}
}