package ru.landgrafhomyak.bgtu.db0.impl

import kotlin.jvm.JvmStatic

internal object Parsers {
	@JvmStatic
	private val commandPattern = Regex("""^/([a-zA-Z0-9_]+)(?:@[a-zA-Z0-9_]*)?(?:\s+([\s\S]+))?$""")

	@JvmStatic
	fun tryParseCommand(text: String): Pair<String, String?>? {
		val match = this.commandPattern.matchEntire(text) ?: return null
		val command = match.groupValues[1]
		val arguments = match.groups[2]?.value
		return Pair(command, arguments)
	}

	@JvmStatic
	private val validNamePattern = Regex("""^(?!\d)[\p{L}_0-9]+$""")

	@JvmStatic
	fun checkIsNameValid(name: String): Boolean = this.validNamePattern.matchEntire(name) != null

	@JvmStatic
	val spaceSeparator = Regex("""\s++""")
}