package ru.landgrafhomyak.bgtu.db0.telegram.impl

import java.net.URI
import java.net.http.HttpClient
import java.net.http.HttpRequest
import java.net.http.HttpRequest.BodyPublishers
import java.net.http.HttpResponse.BodyHandlers
import org.json.JSONObject

class JavaBlockingJson2JsonHttpClient(
	private val jClient: HttpClient
) {
	fun request(url: String, payload: JSONObject): JSONObject =
		this.jClient.send(
			HttpRequest.newBuilder(URI(url))
				.POST(BodyPublishers.ofString(payload.toString(0), Charsets.UTF_8))
				.setHeader("Content-Type", "application/json; charset=utf-8")
				.build(),
			BodyHandlers.ofString()
		).body().let { s -> JSONObject(s) }
}